Outbound Wiki

Automated reply filtering

Recognizing auto-acknowledgments and other non-human replies so they do not enter the normal sales response queue.

An automated reply filter should make one decision before any rep or sequence reacts: is the message from a person or a machine? Read the headers, classify the message, then decide whether it belongs in the human queue. A new inbound message can itself be an automatic reply from somewhere else.1 Replying to it can cause a useless delivery failure or an infinite email loop.2 Run the filter before follow-up, queueing, and sequence-state changes.

Run the filter in order

  1. Read the headers
  2. Assign the message type
  3. Set the queue action
  4. Hold unclear cases
  5. Record the automated outcome

Use the same pass for every inbound message so the filter makes a routing decision before a rep interprets the email.

  1. Read the headers before the message body.

Start with Auto-Submitted, which is defined in RFC 38343 and is the standard way to indicate that a message is an autoreply.4 Read its value and use it in the decision. An Exchange Online out of office example uses Auto-Submitted: auto-generated.5

Check X-Auto-Response-Suppress as a second machine signal. Microsoft defines this header,6 and Microsoft Exchange and Outlook use it.7 Many newsletters set it too.8 Treat it as a routing signal that needs a value check, not as a complete classification by itself.

  1. Assign the message type.

Use the header result to assign a message type before deciding who should handle it. An autoresponse is a program-generated reply to received mail, sent to the bounce address rather than generated by a human user.9 Common automatic replies include vacation messages, challenge-response spam-filtering challenges, list-server replies, and feedback reports.10

Keep the label specific enough for the next action. A vacation message may need a later retry, while a challenge or feedback report may need a different owner. If the signals and message type disagree, leave the message uncertain until someone reviews it.

  1. Set the queue action.

Turn the type into a routing decision. An automated result should leave the normal sales response queue and should not trigger personal follow-up. Automatic reply detection prevents embarrassing follow-ups to prospects who are already in conversation with the sender.11

Keep sequence state separate from queue state. A message can leave the rep queue while the outbound sequence still needs its own decision. This stops a machine response from being treated as the human engagement that changes the sequence.

  1. Hold unclear cases for review.

Give unclear messages a review state. Reliable detection is not always easy,12 and senders can indicate automation in ways beyond the Auto-Submitted header.13

When headers are missing, conflicting, or incomplete, send the message to manual review. The reviewer should decide whether a person took an action, then apply the queue and sequence rules to that decision.

  1. Record the automated outcome separately.

Keep automation labels visible in reporting so they do not disappear into the human reply total. This separates messages that reached a person from those that generated only machine traffic.

  1. Mark messages your own systems send.

If your systems send automatic messages, make them identifiable to receiving filters. Automated responses should include a header such as Auto-Submitted: auto-replied.14

What not to do

Use these as hard stops when reviewing the filter or its output.

  • Do not send a reply to an automatically generated email.15
  • Do not send a reply when Auto-Submitted is present with a value other than no.16
  • Do not let a message with X-Auto-Response-Suppress containing DR, AutoReply, or All enter the reply path.17
  • Do not assume an out of office message has stopped a sequence. Recipient replies stop sequences, while out of office messages do not.18
  • Do not let two automated systems answer one another, because they can exchange replies endlessly and create a mail loop.19
  • Do not count auto-replies, out of office messages, and role-based inboxes in reply or positive reply rates.20

Put the header checks before queue entry, send unclear cases to human review, and keep automated outcomes separate in reporting. This protects the reply queue while leaving sequence decisions attached to human engagement.

Sources

  1. 1
    “However, on occasion, a new message that you just received is itself an automatic reply from somewhere else.”
  2. 2
    “At best, you will get a useless delivery failure. At worst, you will get an infinite email loop and a world of chaos.”
  3. 3
    “Defined in RFC 3834.”
  4. 4
    “This is the ‘official’ standard to indicate your message is an autoreply.”
  5. 5
    “As an example, in Exchange Online, the following is the header of an OOF: Auto-Submitted: auto-generated”
  6. 6
    “Defined by Microsoft”
  7. 7
    “This header is used by Microsoft Exchange, Outlook, and perhaps some other products.”
  8. 8
    “Many newsletters and such also set this.”
  9. 9
    “Auto-responses (automatic replies) are mails sent by a program—as opposed to a human user—in reply to a received mail and sent to the bounce address.”
  10. 10
    “Examples of other auto replies are vacation mails, challenges from challenge-response spam filtering, replies from list servers, and feedback reports.”
  11. 11
    “Automatic reply detection saves embarrassing follow-ups to prospects who are already talking to you.”
  12. 12
    “reliably detecting automatically generated emails is not always easy.”
  13. 13
    “You can also check the Auto-Submitted: header on incoming mail to identify automated messages, but different mail senders also indicate this in other ways.”
  14. 14
    “RFC-38341 recommends that all automated responses contain a header like Auto-Submitted: auto-replied so they can be easily identified, and you should include that header in any automated messages that your bots send.”
  15. 15
    “not send replies to automatically generated emails.”
  16. 16
    “You should not send a reply if Auto-Submitted is present and has a value other than no.”
  17. 17
    “You should not send a reply if X-Auto-Response-Suppress contains DR (“Suppress delivery reports”), AutoReply (“Suppress autoreply messages other than OOF notifications”), or All.”
  18. 18
    “If recipient replies, sequences will automatically stop for that recipient (auto replies like "Out of office" messages will not result in the sequence being stopped).”
  19. 19
    “At worst, two misbehaving bots can endlessly send auto-replies back and forth to each other, creating a mail loop.”
  20. 20
    “Classify them separately so they do not inflate reply and positive reply rates.”